device_type: qemu
job_name: @JOB_NAME@
visibility: public
priority: 100

timeouts:
  job:
    minutes: 60
  action:
    minutes: 60
  connection:
    minutes: 2

context:
  lava_test_results_dir: /var/lib/lava-%s
  arch: aarch64
  machine: virt,secure=off
  cpu: max
  guestfs_interface: virtio
  netdevice: user

actions:

- deploy:
    to: downloads
    failure_retry: 3
    timeout:
      minutes: 60
    images:
      os:
        url: @OS_URL@
        compression: xz
      firmware:
        # These are binaries from ts-testing and hardcoded for now
        url: https://gitlab.com/Linaro/trustedsubstrate/ts-testing/-/jobs/artifacts/main/raw/binaries/QEMU_EFI.fd?job=build
      variables:
        url: https://gitlab.com/Linaro/trustedsubstrate/ts-testing/-/jobs/artifacts/main/raw/binaries/QEMU_VARS.fd?job=build
    postprocess:
      docker:
        image: debian
        steps:
          - apt-get update
          - apt-get install -qy mtools
          - mcopy -i efiboot.wic@@1048576 ::/EFI/BOOT/startup.nsh .
          - sed -i 's#ledge.efi -f.*#ledge.efi -f -s -u validation-linaro-org.s3.eu-west-1.amazonaws.com/testdata/ledge/postmarketos-trailblazer.iso#g' startup.nsh
          - cat startup.nsh
          - mcopy -o -i efiboot.wic@@1048576 startup.nsh ::/EFI/BOOT/

- deploy:
    failure_retry: 3
    timeout:
      minutes: 60
    to: tmpfs
    images:
      os:
        image_arg: -drive id=disk1,file={os},if=none,format=raw -device virtio-blk-device,drive=disk1
          -nographic -device i6300esb,id=watchdog0 -m 8192 -smp 4
        url: downloads://efiboot.wic
      firmware:
        image_arg: -drive if=pflash,unit=0,readonly=on,file={firmware},format=raw
        url: downloads://QEMU_EFI.fd
      variables:
        image_arg: -drive if=pflash,format=raw,readonly=off,file={variables},format=raw
        url: downloads://QEMU_VARS.fd

- boot:
    method: qemu
    media: tmpfs
    docker:
      image: registry.gitlab.com/linaro/blueprints/qemu-swtpm
      binary: /usr/local/bin/qemu-system-aarch64-swtpm
    timeout:
      minutes: 40
    auto_login:
      login_prompt: 'login:'
      username: "root"
    prompts:
      - root@(.*):[/~]#
      - root@(.*)\~
    transfer_overlay:
      download_command: wget -t 20
      unpack_command: tar -C /var/lib/ -xzvf
